local t = Def.ActorFrame{
	InitCommand=cmd(fov,90;SetDrawByZPosition,true);
};
-- hey let's make a starfield

-- also some bigger stars

-- put in the nexus
local nexusTex = THEME:GetPathB("ScreenWithMenuElements","background/_nexus");
t[#t+1] = LoadActor(nexusTex)..{
	InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;z,175;blend,'BlendMode_Add';diffusealpha,0.75);
	OnCommand=cmd(spin;effectmagnitude,0,0,-60);
};

-- and I want a tunnel for breakfast
local tunnelPiece = Def.ActorFrame{
	LoadActor("_ring base")..{
		InitCommand=cmd(blend,Blend.Add);
	};
	LoadActor("_ring sine1")..{
		InitCommand=cmd(blend,Blend.Add;);
		OnCommand=cmd(spin;effectmagnitude,0,0,30);
	};
	LoadActor("_ring sine2")..{
		InitCommand=cmd(blend,Blend.Add;);
		OnCommand=cmd(spin;effectmagnitude,0,0,-30);
	};
};

-- example single tunnel piece originally used for testing
--[[
t[#t+1] = tunnelPiece..{
	InitCommand=cmd(Center;z,0);
	OnCommand=cmd(linear,5;addz,300);
};
--]]

--[[
t[#t+1] = Def.Quad{
	InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;z,-800;zoomto,300,300;diffuse,color("0,0,0,0.975");zwrite,true;clearzbuffer,true;);
};
--]]

-- scroller time
local ringSpacing = 256;
local effectStrength = 50; -- was 20

t[#t+1] = Def.ActorScroller{
	NumItemsToDraw = 20;
	SecondsPerItem = 0.5;
	TransformFunction = function( self, offset, itemIndex, numItems )
		self:z(offset * -ringSpacing);
		--self:x( (math.cos(offset)*90) );
		self:diffusealpha( math.random(0.35,0.8) )
	end;
	InitCommand=cmd(Center;SetLoop,true;);
	OnCommand=cmd(ScrollWithPadding,3,3;);

	children = {
		tunnelPiece..{
			InitCommand=cmd(diffuse,HSV(45,1,1);bob;effectmagnitude,effectStrength,0,0);
		};
		tunnelPiece..{
			InitCommand=cmd(diffuse,HSV(180,1,1);bob;effectoffset,1.5;effectmagnitude,-effectStrength,0,0);
		};
		tunnelPiece..{
			InitCommand=cmd(diffuse,HSV(225,1,1);bob;effectoffset,3.0;effectmagnitude,effectStrength,0,0);
		};
		tunnelPiece..{
			InitCommand=cmd(diffuse,HSV(320,1,1);bob;effectoffset,4.5;effectmagnitude,-effectStrength,0,0);
		};
	};
};

-- and then some wavy lines in the back that appear sometimes

-- here's some clouds to draw over it maybe
local cloudTex = THEME:GetPathB("ScreenTitleMenu","background/_clouds");
t[#t+1] = LoadActor(cloudTex)..{
	InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y*1.5;blend,'BlendMode_Add';glow,color("1,1,1,0.1");diffusealpha,0.25;rotationx,50);
	OnCommand=cmd(texcoordvelocity,0,-0.125;customtexturerect,0,0,4,4;zoomx,4;zoomy,2.75;);
};

return t;