-- ScreenEdit background is like the common background without the particle bubbles
local bgColors = {
	Primary   = HSVA(160, 1.0, 0.75, 0.4), -- was 44,1,0.75,0.4
	Secondary = HSVA(176, 0.8, 0.65, 0.4), -- was 52,0.8,0.65,0.4
};

local t = Def.ActorFrame{
	Name="Background";
	InitCommand=cmd(fov,95);

	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg base") )..{ InitCommand=cmd(Center); };
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg blur") )..{ InitCommand=cmd(Center;diffusealpha,0.6); };
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg over1") )..{ InitCommand=cmd(Center;diffusealpha,0.35); };
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg whiteglow") )..{ InitCommand=cmd(Center;diffusealpha,0.5;diffuseshift;effectcolor1,color("1,1,1,1");effectcolor1,color("1,1,1,0.25");effectperiod,30); };
	-- xxx: this one needs overlay in order to function properly...
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg over2") )..{ InitCommand=cmd(Center;diffusealpha,0.25;diffuseshift;effectcolor1,color("1,1,1,1");effectcolor1,color("1,1,1,0.25");effectperiod,45); };
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg over1") )..{ InitCommand=cmd(Center;zoom,1.5;diffusealpha,0.45;bob;effectmagnitude,-64,64,0;effectperiod,15;); };
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_bg over2") )..{ InitCommand=cmd(Center;zoom,1.25;diffusealpha,0.325;bob;effectmagnitude,0,-24,0;effectperiod,20;effectoffset,0.25); };
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_nexus") )..{
		InitCommand=cmd(x,SCREEN_CENTER_X*0.175;y,SCREEN_CENTER_Y;diffusealpha,0.075;blend,'BlendMode_Add';faderight,0.75;rotationy,20);
		OnCommand=cmd(spin;effectperiod,60;effectmagnitude,0,0,15);
	};
	Def.Quad{
		InitCommand=cmd(Center;FullScreen;diffuse,bgColors.Primary;blend,'BlendMode_WeightedMultiply';);
		OnCommand=cmd(diffuseshift;effectperiod,60;effectcolor1,bgColors.Primary;effectcolor2,bgColors.Secondary);
	};
	LoadActor( THEME:GetPathB("ScreenWithMenuElements","background/_diag") )..{
		InitCommand=cmd(Center;diffusealpha,0.175;blend,'BlendMode_Add';rotationx,-7;scaletocover,SCREEN_LEFT-(SCREEN_CENTER_X*0.125),SCREEN_TOP,SCREEN_RIGHT+(SCREEN_CENTER_X*0.125),SCREEN_BOTTOM);
		OnCommand=cmd(glowshift;effectcolor1,color("1,1,1,0.125");effectcolor2,color("1,1,1,0.0875");effectperiod,8.25;);
	};

	-- see maybe i can be nice to the edit folk
	Def.Quad{
		InitCommand=cmd(xy,SCREEN_LEFT,SCREEN_CENTER_Y;horizalign,left;zoomto,SCREEN_CENTER_X*0.425,SCREEN_HEIGHT;diffuse,color("0,0,0,0.6375"));
	};
	Def.Quad{
		InitCommand=cmd(xy,SCREEN_RIGHT,SCREEN_CENTER_Y;horizalign,right;zoomto,SCREEN_CENTER_X*0.425,SCREEN_HEIGHT;diffuse,color("0,0,0,0.6375"));
	};
};

return t;