--[[ a sm-ssc BPMDisplay, by NAKET Coder ]]

-- config:
local frameWidth = 256;
local frameHeight = 16;
local borderSize = 2;

local t = Def.ActorFrame{
	--[[ frame ]]
	Def.Quad{
		Name="Border";
		InitCommand=cmd(zoomto,frameWidth+borderSize,frameHeight+borderSize;diffusealpha,0.5);
	};
	Def.Quad{
		Name="Background";
		InitCommand=cmd(zoomto,frameWidth,frameHeight;diffuse,color("0,0,0,0.25");diffuserightedge,color("0.2,0.2,0.2,0.25"));
	};

	--[[ BPMDisplay ]]
	Def.ActorFrame{
		Name="BPMFrame";
		InitCommand=cmd(x,-SCREEN_CENTER_X*0.25);
		Def.BPMDisplay{
				File=THEME:GetPathF("", "mentone/_24px");
				Name="BPMDisplay";
				InitCommand=cmd(x,2;horizalign,left;zoom,0.6;shadowlength,1;shadowcolor,color("#00000088"));
				OnCommand=cmd(stoptweening);
				OffCommand=cmd(linear,0.2;diffusealpha,0);
				SetCommand=function(self) self:SetFromGameState() end;
				CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
				CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
			};
		Font("mentone","24px")..{
			Name="BPMLabel";
			InitCommand=cmd(settext,"BPM";zoom,0.6;horizalign,right;shadowlength,1;shadowcolor,color("#00000088"));
			OffCommand=cmd(linear,0.2;diffusealpha,0);
			SetCommand=function(self)
				local song = GAMESTATE:GetCurrentSong();
				self:stoptweening();
				self:linear(0.25);
				if song then
					self:diffuse( song:GetTimingData():HasStops() and color("#55CCEE") or color("#FFFFFF") );
				else
					self:diffuse( color("#FFFFFF") );
				end;
			end;
			CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
			CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
		};
	};

	--[[ time text ]]
	Font("mentone","24px")..{
		Name="TimeEnd";
		InitCommand=cmd(x,SCREEN_CENTER_X*0.32;zoom,0.6;horizalign,right;shadowlength,1;shadowcolor,color("#00000088"));
		OnCommand=cmd(playcommand,"Set";);
		SetCommand=function(self)
			local song, time;

			if GAMESTATE:IsCourseMode() then
				if GAMESTATE:GetCurrentCourse() then
					local course = GAMESTATE:GetCurrentCourse();
					local trail;
					if GAMESTATE:GetCurrentTrail(GAMESTATE:GetMasterPlayerNumber()) then
						trail = GAMESTATE:GetCurrentTrail(GAMESTATE:GetMasterPlayerNumber());
						time = course:GetTotalSeconds(trail:GetStepsType());
					end;
				end;
			else
				song = GAMESTATE:GetCurrentSong();
				if song then
					time = song:MusicLengthSeconds();
				end;
			end;

			if time then
				if time == 105.00 then
					-- r21 lol; it seems to work on other songs but
					-- if a song is exactly 1:45 it won't work lol
					if SSC then
						-- in sm-ssc, we have Song:GetStepsSeconds()
						time = song:GetStepsSeconds();
						local finalText = SecondsToMSSMsMs(time);
						self:skewx(-0.1);
						self:diffusebottomedge( HSV(0,0.45,0.975) );
						self:settext( string.sub(finalText, 0, string.len(finalText)-3));
					else
						self:settext("not 1:45");
						self:skewx(0);
						self:diffusebottomedge( color("#FFFFFF") );
					end;
				else
					local finalText = SecondsToMSSMsMs(time);
					self:settext( string.sub(finalText, 0, string.len(finalText)-3) );
					self:skewx(0);
					self:diffusebottomedge( color("#FFFFFF") );
				end;
			else
				self:settext( "0:00" );
				self:skewx(0);
				self:diffusebottomedge( color("#FFFFFF") );
			end;
		end;
		CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
		CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
	};
};

return t;