-- this is what ends up in the bottom frame in non-course mode.
local t = Def.ActorFrame{};

-- p1 panedisplay etc. section
t[#t+1] = Def.ActorFrame{
	Name="P1StepsInfo";
	InitCommand=cmd(xy,WideScale(SCREEN_WIDTH*0.225,SCREEN_WIDTH*0.264583),(SCREEN_CENTER_Y*1.26)+1);
	BeginCommand=function(self)
		self:zoomx( GAMESTATE:IsHumanPlayer(PLAYER_1) and 1 or 0 );
	end;
	-- handle late join
	PlayerJoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_1 then
			self:decelerate(0.25);
			self:zoomx(1);
		end;
	end;
	PlayerUnjoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_1 then
			self:accelerate(0.25);
			self:zoomx(0);
		end;
	end;

	-- left side: PaneDisplay
	LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 124, 48, color("1,1,1,0.225") )..{
		InitCommand=cmd(x,-68;blend,Blend.Add);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
	LoadActor("PaneDisplay",PLAYER_1)..{
		InitCommand=cmd(x,-122;y,-22.5);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
	-- splitter frame
	--[[
	Def.Quad{
		InitCommand=cmd(zoomto,4,60;diffuse,color("0,0,0,0.3125"));
		OffCommand=cmd(accelerate,0.5;zoomy,0);
	};
	--]]
	-- splitter
	Def.Quad{
		InitCommand=cmd(y,28;zoomto,2,56;vertalign,bottom;blend,Blend.Add;diffusecolor,PlayerColor(PLAYER_1);diffusealpha,0.625;);
		--[[
		ChangeDividerSizeMessageCommand=function(self,param)
			self:stoptweening();
			self:linear(0.125);
			if param.PlayerNumber == PLAYER_1 then
				if param.Score <= -1 then
					self:zoomy(56);
				else
					self:zoomy(param.Score*56);
				end;
			end;
		end;
		--]]
		OffCommand=cmd(accelerate,0.5;zoomy,0);
	};
	-- right side: RadarBars
	LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 124, 48, color("1,1,1,0.225") )..{
		InitCommand=cmd(x,68;blend,Blend.Add);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
	LoadActor("RadarBars",PLAYER_1)..{
		InitCommand=cmd(x,10;y,-20);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
};

-- p2 data extended (if not two players joined)
-- todo: figure out something decent to do with this section
t[#t+1] = Def.ActorFrame{
	InitCommand=cmd(xy,WideScale(SCREEN_WIDTH*0.225,SCREEN_WIDTH*0.264583),(SCREEN_CENTER_Y*1.26)+1);
	BeginCommand=function(self)
		if GAMESTATE:GetNumPlayersEnabled() == 1 and GAMESTATE:GetMasterPlayerNumber() == PLAYER_2 then
			self:zoomy(1);
		else
			self:zoomy(0);
		end;
	end;
	-- handle late join
	PlayerJoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_1 then
			self:decelerate(0.25);
			self:zoomy(0);
		end;
	end;
	PlayerUnjoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_1 then
			self:accelerate(0.25);
			self:zoomy(1);
		end;
	end;
	--[[
	Font("mentone","24px")..{
		Text="(WIP section)";
		InitCommand=cmd(zoom,0.8;shadowlength,1;shadowcolor,color("0.2,0.2,0.2,0.375"));
		OffCommand=cmd(bouncebegin,0.5;rotationz,360;zoom,0);
	};
	--]]
	Font("mentone","24px")..{
		Text=Screen.String("JoinPlayer"..pname(PLAYER_1));
		InitCommand=cmd(zoom,0.5;y,20;shadowlength,1;shadowcolor,color("0.2,0.2,0.2,0.375"));
		OnCommand=cmd(zoomx,6;linear,0.25;zoomx,0.5;);
		OffCommand=cmd(linear,0.5;zoomx,6;zoomy,0;diffusealpha,0);
	};
};

if not GAMESTATE:IsCourseMode() then
	t[#t+1] = Def.Quad{
		Name="PlayerSplitter";
		InitCommand=cmd(x,WideScale(SCREEN_WIDTH*0.225,SCREEN_WIDTH*0.264583);y,SCREEN_CENTER_Y*1.41667;diffusealpha,0.5);
		OnCommand=cmd(linear,0.2;zoomto,265,2);
		OffCommand=cmd(linear,0.2;zoomx,0);
	};
end;

-- p2 panedisplay etc. section
t[#t+1] = Def.ActorFrame{
	Name="P2StepsInfo";
	InitCommand=cmd(xy,WideScale(SCREEN_WIDTH*0.225,SCREEN_WIDTH*0.264583),(SCREEN_CENTER_Y*1.56)+1);
	BeginCommand=function(self)
		self:zoomx( GAMESTATE:IsHumanPlayer(PLAYER_2) and 1 or 0 );
	end;
	-- handle late join
	PlayerJoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_2 then
			self:decelerate(0.25);
			self:zoomx(1);
		end;
	end;
	PlayerUnjoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_2 then
			self:accelerate(0.25);
			self:zoomx(0);
		end;
	end;

	-- left side: PaneDisplay
	LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 124, 48, color("1,1,1,0.225") )..{
		InitCommand=cmd(x,-68;blend,Blend.Add);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
	LoadActor("PaneDisplay",PLAYER_2)..{
		InitCommand=cmd(x,-122;y,-22.5);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
	-- splitter
	Def.Quad{
		InitCommand=cmd(y,28;zoomto,2,56;vertalign,bottom;blend,Blend.Add;diffusecolor,PlayerColor(PLAYER_2);diffusealpha,0.625;);
		--[[
		ChangeDividerSizeMessageCommand=function(self,param)
			if param.PlayerNumber == PLAYER_2 then
				if param.Score <= -1 then
					self:zoomy(56)
				else
					self:zoomy(param.Score*56);
				end;
			end;
		end;
		--]]
		OffCommand=cmd(accelerate,0.5;zoomy,0);
	};
	-- right side: RadarBars
	LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 124, 48, color("1,1,1,0.225") )..{
		InitCommand=cmd(x,68;blend,Blend.Add);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
	LoadActor("RadarBars",PLAYER_2)..{
		InitCommand=cmd(x,10;y,-20);
		OffCommand=cmd(linear,0.5;zoomy,0);
	};
};

-- p1 data extended (if not two players joined)
-- todo: figure out something decent to do with this section
t[#t+1] = Def.ActorFrame{
	InitCommand=cmd(xy,WideScale(SCREEN_WIDTH*0.225,SCREEN_WIDTH*0.264583),(SCREEN_CENTER_Y*1.56)+1);
	BeginCommand=function(self)
		if GAMESTATE:GetNumPlayersEnabled() == 1 and GAMESTATE:GetMasterPlayerNumber() == PLAYER_1 then
			self:zoomy(1);
		else
			self:zoomy(0);
		end;
	end;
	-- handle late join
	PlayerJoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_2 then
			self:decelerate(0.25);
			self:zoomy(0);
		end;
	end;
	PlayerUnjoinedMessageCommand=function(self, params)
		if params.Player == PLAYER_2 then
			self:accelerate(0.25);
			self:zoomy(1);
		end;
	end;
	--[[
	Font("mentone","24px")..{
		Text="(WIP section)";
		InitCommand=cmd(zoom,0.8;shadowlength,1;shadowcolor,color("0.2,0.2,0.2,0.375"));
		OffCommand=cmd(bouncebegin,0.5;rotationz,360;zoom,0);
	};
	--]]
	Font("mentone","24px")..{
		Text=Screen.String("JoinPlayer"..pname(PLAYER_2));
		InitCommand=cmd(zoomy,0.5;y,48;shadowlength,1;shadowcolor,color("0.2,0.2,0.2,0.375"));
		OnCommand=cmd(zoomx,6;linear,0.25;zoomx,0.5;);
		OffCommand=cmd(linear,0.5;zoomx,6;zoomy,0;diffusealpha,0);
	};
};

return t;