--[[
RadarBars 2.1 / licensed to NAKET Team from spinal shark collective

( 004 )

nc[NT]: yeah man it's gonna cost you money to implement this soon
syn[NT]: lol i no rite
syn[NT]: j/k i would never charge for shit
]]

local Player = ...
assert(Player,"Must pass in a player, dingus");

local radarCategoryValues = {
	{ Category = 'RadarCategory_Stream', Text = THEME:GetString("RadarCategory","Stream"), Color = HSV(32,0.5,1) },
	{ Category = 'RadarCategory_Voltage', Text = THEME:GetString("RadarCategory","Voltage"), Color = HSV(56,0.325,1) },
	{ Category = 'RadarCategory_Air', Text = THEME:GetString("RadarCategory","Air"), Color = HSV(192,0.325,1) },
	{ Category = 'RadarCategory_Freeze', Text = THEME:GetString("RadarCategory","Freeze"), Color = Colors.IcyBlue },
	{ Category = 'RadarCategory_Chaos', Text = THEME:GetString("RadarCategory","Chaos"), Color = HSV(356,0.5,1) }
};

local rb = Def.ActorFrame{
	Name="RadarBars"..Player;
};

local barMaxWidth = 116; -- maximum width for bar.
local barHeight = 8; -- this is mainly used for spacing issues.
local offset = barHeight+2; -- vertical offset between bars
local fontZoom = 0.35; -- font zooming (mentone)
local rv; -- for storing the RadarValues.

-- other things
local TextStroke = color("0,0,0,0.625");

-- pre-runthrough setup of some very important junk:
local Selection; -- either song or course.
local bIsCourseMode = GAMESTATE:IsCourseMode();
local StepsOrTrail;

for idx, cat in pairs(RadarCategory) do
	if idx < 6 then -- only do Stream, Voltage, Air, Freeze, Chaos Emeralds
		rb[#rb+1] = Def.ActorFrame{
			-- bar BG
			Def.Quad{
				InitCommand=cmd(y,((idx-1)*offset);zoomto,barMaxWidth,barHeight;horizalign,left;diffuse,color("0,0,0,0.25"));
			};

			-- the bar itself is dynamic and therefore needs more code.
			Def.Quad{
				InitCommand=cmd(y,((idx-1)*offset);zoomto,0,barHeight;horizalign,left;diffuse,radarCategoryValues[idx].Color;diffusebottomedge,Brightness(radarCategoryValues[idx].Color,0.65));
				BeginCommand=cmd(playcommand,"Set");
				SetCommand=function(self)
					-- due to a visual display bug, you have to stop effects
					-- here for them to match up.
					self:stopeffect();

					-- here's the fun part.
					local width = 0; -- this gets changed.

					if bIsCourseMode then
						Selection = GAMESTATE:GetCurrentCourse();
						StepsOrTrail = GAMESTATE:GetCurrentTrail(Player);
					else
						Selection = GAMESTATE:GetCurrentSong();
						StepsOrTrail = GAMESTATE:GetCurrentSteps(Player);
					end;

					if not Selection then width = 0;
					else
						-- we have a selection.
						-- Make sure there's something to grab values from.
						if not StepsOrTrail then width = 0;
						else
							rv = StepsOrTrail:GetRadarValues(Player);
							-- the graphic is 2px wide for whatever reason
							width = rv:GetValue(cat) * (barMaxWidth);
						end;
						if GAMESTATE:IsCourseMode() then
							-- divide by the number of songs in the course
							width = width / Selection:GetEstimatedNumStages();
						end;
					end;

					-- glow super insane junk
					if rv and rv:GetValue(cat) >= 0.99 then
						self:glowshift();
						self:effectcolor1( color("1,1,1,0.05") );
						self:effectcolor2( color("1,1,1,0.375") );
					else
						self:stopeffect();
					end;

					self:finishtweening();
					self:decelerate(0.25);
					self:zoomx( clamp(width,0,barMaxWidth) );
				end;
				-- generic song/course changes
				CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
				CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
				-- player based changes
				CurrentStepsP1ChangedMessageCommand=function(self)
					if Player == PLAYER_1 then self:playcommand("Set"); end;
				end;
				CurrentTrailP1ChangedMessageCommand=function(self)
					if Player == PLAYER_1 then self:playcommand("Set"); end;
				end;
				CurrentStepsP2ChangedMessageCommand=function(self)
					if Player == PLAYER_2 then self:playcommand("Set"); end;
				end;
				CurrentTrailP2ChangedMessageCommand=function(self)
					if Player == PLAYER_2 then self:playcommand("Set"); end;
				end;
			};

			-- label
			Font("mentone","24px")..{
				Text=THEME:GetString("RadarCategories",cat);
				InitCommand=cmd(x,2;y,((idx-1)*offset)-0.5;shadowlength,0;horizalign,left;zoom,fontZoom;strokecolor,TextStroke);
			};

			-- originally meant as a debug feature, keeping in.
			Font("mentone","24px")..{
				InitCommand=cmd(x,barMaxWidth-2;y,((idx-1)*offset-1)+0.5;zoom,fontZoom;shadowlength,0;horizalign,right;diffusealpha,0.9;strokecolor,TextStroke);
				BeginCommand=cmd(playcommand,"Set");
				-- duplicated code, I must be very proud of myself
				SetCommand=function(self)
					local percent = 0.0;

					if bIsCourseMode then
						Selection = GAMESTATE:GetCurrentCourse();
						StepsOrTrail = GAMESTATE:GetCurrentTrail(Player);
					else
						Selection = GAMESTATE:GetCurrentSong();
						StepsOrTrail = GAMESTATE:GetCurrentSteps(Player);
					end;

					if not Selection then percent = 0.0;
					else
						-- we have a selection.
						-- Make sure there's something to grab values from.
						if not StepsOrTrail then percent = 0.0;
						else
							rv = StepsOrTrail:GetRadarValues(Player);
							percent = rv:GetValue(cat)*100;
						end;
						if GAMESTATE:IsCourseMode() then
							-- divide by the number of songs in the course
							percent = percent / Selection:GetEstimatedNumStages();
						end;
					end;
					--self:settext( string.format("%.2f",percent) );
					percent = percent < 0 and "?" or math.ceil(percent)
					self:settext( percent );
				end;
				-- generic song/course changes
				CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
				CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
				-- player based changes
				CurrentStepsP1ChangedMessageCommand=function(self)
					if Player == PLAYER_1 then self:playcommand("Set"); end;
				end;
				CurrentTrailP1ChangedMessageCommand=function(self)
					if Player == PLAYER_1 then self:playcommand("Set"); end;
				end;
				CurrentStepsP2ChangedMessageCommand=function(self)
					if Player == PLAYER_2 then self:playcommand("Set"); end;
				end;
				CurrentTrailP2ChangedMessageCommand=function(self)
					if Player == PLAYER_2 then self:playcommand("Set"); end;
				end;
			};
		};
	end;
end;

return rb;