local song = GAMESTATE:GetCurrentSong();
local course = GAMESTATE:GetCurrentCourse();

local t = Def.ActorFrame{
	Def.ActorFrame{
		Name="SongInfo";
		InitCommand=cmd(Center);

		-- genre
		Font("mentone", "24px")..{
			InitCommand=cmd(y,-28;shadowlength,1;diffusealpha,0;zoomx,1000;maxwidth,SCREEN_WIDTH*0.8);
			BeginCommand=function(self)
				local genre = GAMESTATE:IsCourseMode() and "" or song:GetGenre();
				if genre == "" then
					self:skewx(-0.1);
					genre = GetRandomGenre();
				else
					self:skewx(0);
				end;
				self:settext(genre);
			end;
			OnCommand=cmd(queuecommand,"Anim");
			AnimCommand=cmd(sleep,0.5;decelerate,0.5;diffusealpha,1;zoom,0.75);
			OffCommand=cmd(decelerate,0.75;zoom,1.5;addy,-32;diffusealpha,0);
		};

		-- title
		--Font("scooter", "32px metal")..{
		Font("sf willamette extended", "32px chrome")..{
			Text=GAMESTATE:IsCourseMode() and course:GetDisplayFullTitle() or song:GetDisplayFullTitle();
			InitCommand=cmd(shadowlength,0;maxwidth,SCREEN_WIDTH*0.8;diffusealpha,0);
			BeginCommand=function(self)
				if self:GetText() == "DVNO" then
					self:diffuse( color("#FFCC0000") );
				else
					self:diffuse( color("1,1,1,0") );
				end;
			end;
			OnCommand=cmd(queuecommand,"Anim");
			AnimCommand=cmd(sleep,0.5;decelerate,0.4;diffusealpha,1);
			OffCommand=cmd(decelerate,0.75;zoom,2;diffusealpha,0);
		};

		-- dupe title (effect)
		--Font("scooter", "32px metal")..{
		Font("sf willamette extended", "32px chrome")..{
			Text=GAMESTATE:IsCourseMode() and course:GetDisplayFullTitle() or song:GetDisplayFullTitle();
			InitCommand=cmd(shadowlength,0;maxwidth,SCREEN_WIDTH*0.8;diffuse,color("0,0.9,1,1");blend,'BlendMode_Add');
			--OnCommand=cmd(accelerate,0.5;zoom,2;diffusealpha,0.5;hibernate,0.2;accelerate,0.5;diffusealpha,0);
			OnCommand=cmd(queuecommand,"Anim");
			AnimCommand=cmd(diffusealpha,0;zoom,1;sleep,0.5;linear,0.05;diffusealpha,1;decelerate,0.4;zoom,1.5;diffusealpha,0.5;accelerate,0.1;zoomx,1000;zoomy,0.2;diffusealpha,0);
		};

		-- artist
		Font("mentone", "24px")..{
			Text=GAMESTATE:IsCourseMode() and course:GetEstimatedNumStages().." stage(s)" or song:GetDisplayArtist();
			InitCommand=cmd(y,28;shadowlength,1;diffusealpha,0;zoomx,1000;maxwidth,SCREEN_WIDTH*0.8);
			OnCommand=cmd(queuecommand,"Anim");
			AnimCommand=cmd(sleep,0.5;decelerate,0.5;diffusealpha,1;zoom,0.75);
			OffCommand=cmd(decelerate,0.75;zoom,1.5;addy,32;diffusealpha,0);
		};
	};
};

return t;