local index = Var("GameCommand"):GetIndex();
local name = Var("GameCommand"):GetName();

local LineSpacing = 96;
local VertHeight  = 128;

local rot = { x = 0, y = 0, z = 0 };

local t = Def.ActorFrame{
	-- vert lines
	Def.Quad{
		InitCommand=cmd(x,-LineSpacing;zoomto,2,VertHeight;fadebottom,0.15;fadetop,0.15);
		GainFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFF186"));
		LoseFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFFFFF"));
		OffFocusedCommand=cmd(accelerate,0.15;zoomx,4;sleep,0.5;decelerate,0.5;diffusealpha,0);
		OffUnfocusedCommand=cmd(accelerate,0.15;zoomy,0);
	};
	Def.Quad{
		InitCommand=cmd(x,LineSpacing;zoomto,2,VertHeight;fadetop,0.15;fadebottom,0.15);
		GainFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFF186"));
		LoseFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFFFFF"));
		OffFocusedCommand=cmd(accelerate,0.15;zoomx,4;sleep,0.5;decelerate,0.5;diffusealpha,0);
		OffUnfocusedCommand=cmd(accelerate,0.15;zoomy,0);
	};
	
	-- horiz lines
	Def.Quad{
		InitCommand=cmd(y,-64;zoomto,194,2;faderight,0.15;fadeleft,0.15);
		GainFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFF186"));
		LoseFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFFFFF"));
		OffFocusedCommand=cmd(accelerate,0.15;zoomx,4;sleep,0.5;decelerate,0.5;diffusealpha,0);
		OffUnfocusedCommand=cmd(accelerate,0.15;zoomy,0);
	};
	Def.Quad{
		InitCommand=cmd(y,64;zoomto,194,2;fadeleft,0.15;faderight,0.15);
		GainFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFF186"));
		LoseFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFFFFF"));
		OffFocusedCommand=cmd(accelerate,0.15;zoomx,4;sleep,0.5;decelerate,0.5;diffusealpha,0);
		OffUnfocusedCommand=cmd(accelerate,0.15;zoomy,0);
	};
	
	-- item background
	Def.Quad{
		InitCommand=cmd(zoomto,190,VertHeight);
		GainFocusCommand=cmd(stoptweening;decelerate,0.75;diffuse,color("0.35,0.35,0.35,0.8");diffusetopedge,color("0.5,0.5,0.5,0.15"));
		LoseFocusCommand=cmd(stoptweening;accelerate,0.3;diffuse,color("0.5,0.5,0.5,0.5");diffusetopedge,color("1,1,1,0"));
		
		OffFocusedCommand=function(self)
			self:sleep(0.5);
			self:decelerate(0.5);
			self:zoomy(0);
		end;
		OffUnfocusedCommand=cmd(accelerate,0.5;zoomy,0);
	};
	-- item bg shine
	Def.Quad{
		--InitCommand=cmd(zoomto,190,20;y,-(VertHeight/2);vertalign,top;diffuse,color("1,1,1,0");fadebottom,0.25;blend,'BlendMode_Add');
		InitCommand=cmd(zoomto,190,20; y,-(VertHeight/2);vertalign,top;
						diffuse,color("0.8,0.8,0.8,0.5");
						fadetop,0.15;
						fadebottom,0.75;
						--diffusebottomedge,color("1,1,1,0.5");
						blend,'BlendMode_Add'
		);
		GainFocusCommand=cmd(diffusealpha,0.5;accelerate,0.2;addy,VertHeight/2;diffusealpha,0);
		LoseFocusCommand=cmd(stoptweening;diffusealpha,0;y,-(VertHeight/2));
	};
	
	LoadActor( THEME:GetPathG("_options","icons/_"..Var("GameCommand"):GetName()) )..{
		GainFocusCommand=cmd(linear,0.2;y,-24;diffusealpha,1);
		LoseFocusCommand=cmd(stoptweening;linear,0.2;y,0;diffusealpha,0.25);
	};
	
	-- title
	Font("sf theramin gothic", "36px") ..{
		Name="Choice"..index;
		Text=THEME:GetString( Var("LoadingScreen"), Var("GameCommand"):GetName() );
		InitCommand=cmd(shadowlength,2;maxwidth,176);
		GainFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#FFFFFF");addy,8;glowshift;effectcolor2,1,0.9,0.33,0.25);
		LoseFocusCommand=cmd(finishtweening;linear,0.2;diffuse,color("#888888");y,0;stopeffect);
		DisabledCommand=cmd(diffuse,0.5,0.5,0.5,1);
		OffFocusedCommand=cmd(decelerate,0.5;zoom,1.25;sleep,0.5;decelerate,0.5;diffusealpha,0);
		OffUnfocusedCommand=cmd(accelerate,0.5;diffusealpha,0);
	};
	
	-- explanation
	Def.Actor{
		Name="Proxy"..index;
		GainFocusCommand=function(self)
			MESSAGEMAN:Broadcast("ServiceItemChanged",{ Name = name });
		end;
	};
};

return t;